/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATmega88+ATA6824 
** Pʕ	: ADC_task.h
** 		: ͯ ̧
**			  d(VSHUNT)Ad(Vbat)Axݒ̎悷ADCǗ
**
**  :  		  t: : :
** 1.0   2007N124  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/

#ifndef ADC_TASK_H
#define ADC_TASK_H

/*_____ ݸٰ ____________________________________________________________*/

/*_____ ϸ ________________________________________________________________*/

#define Set_ADC_Channel(Channel)	(ADMUX &= ( (1<<REFS1) | (1<<REFS0) | (1<<ADLAR)), \	//!< ADCّI
									ADMUX |=  Channel & ((1<<MUX3) | (1<<MUX2) | (1<<MUX1) | (1<<MUX0)))
#define ADC_start_conv()			(ADCSRA |= (1<<ADSC))					//!< VADC̎Jn
#define ADC_end_conv()				((ADCSRA & (1<<ADIF)) == (1<<ADIF))		//!< ϊI荞׸ޒ
#define ADC_clear_end_conv_flag()	(ADCSRA |= (1<<ADIF))					//!< ADC׸ ؾĂƐVϊJn
#define ADC_data_reg()				(ADC)									//!< ADCް ڼ޽


/*_____ ` _______________________________________________________________*/
//! @typedef ADC_state_t ADCԒ`
//! ADC_state_tADC̎vɎg܂B
typedef enum
{
	ADC_INIT_TASK					//!< dJn
	ADC_WAIT_CURRENT_MEAS,			//!< d̎҂
	ADC_WAIT_SPEED_SET_MEAS,		//!< ]ޑx̎҂
	ADC_WAIT_VBAT_MEAS,				//!< VbatϊI҂
}ADC_state_t;						// ADCϊԋ@\^`


// @defgroup ADC_channels ADCْ`
// @{
#define	ADC0	0x00
#define	ADC1	(                         (1<<MUX0) )
#define	ADC2	(             (1<<MUX1)             )
#define	ADC3	(             (1<<MUX1) | (1<<MUX0) )
#define	ADC4	((1<<MUX2)                          )
#define	ADC5	((1<<MUX2)              | (1<<MUX0) )
#define	ADC6	((1<<MUX2) |  (1<<MUX1)             )
#define	ADC7	((1<<MUX2) |  (1<<MUX1) | (1<<MUX0) )
// @}


/*_____ Sϐ ___________________________________________________________*/

/*_____ ^錾 ___________________________________________________________*/

void ADC_Init(void);					// ADC
void ADC_task(void);					// ADC̎Ǘ
unsigned int adc_get_speed(void);		// xݒlԂ܂B
unsigned int adc_get_current(void);		// 肵dԂ܂B
unsigned int adc_get_V_bat(void);		// 肵V_basԂ܂B
#endif //ADC_TASK_H
