/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATmega88+ATA6824 
** Pʕ	: ADC_task.c
** 		: d(VSHUNT)Ad(Vbat)Axݒ̎悷ADCǗ
**
**  :  		  t: : :
** 1.0   2007N212  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/


/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "ADC_task.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ ^錾 ___________________________________________________________*/

/*_____ Sϐ ___________________________________________________________*/

unsigned int Speed_set;			//!< ADCϊ
unsigned int current;			//!< 肵dl(VshuntM)
unsigned int V_bat;				//!< ~drdl


/*_____ I֐ ___________________________________________________________*/

/*! @brief ADC_Initٰ: xݒl̎悷悤ADC
 * ȉADCݒ:
 *   - ADCް ڼ޽ŕϊʉE킹
 *   - QƊdAREF݂ł̊OݻtAVCC
 *   - ADC0I
 *   - ADC
 *   - ADCۯclk/128ɐݒ
 *   - ADC0(PC0)޼ٓ͊ɏՕ֎~
 * ǂ/
 *   - ADMUX	
 *   - ADCSRA	
 *   - DIDR0	
 */
void ADC_Init(void)
{
	/* ADC */
	ADMUX |= (1 << REFS0);		// ADCŕϊʉEAAREF݂ł̊OݻtAVCCAADC0I
	ADCSRA |= (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);	// ADCAW:clk/128
	DIDR0 |= (1<<ADC0D);		// ADC0޼ٓ͊ɏՕ֎~
}


/*! @brief ADC_task͓dA]ޑxAVbatႵ܂B
 *  SĂ̍̎v悵܂B̎抮Aʂ擾ĎJn܂B
 */
void ADC_task(void)
{
	static ADC_state_t ADC_state = ADC_INIT_TASK;	// ADCԋ@\

	switch(ADC_state)
	{
	case ADC_INIT_TASK:								// dJn
		Set_ADC_Channel(ADC0);						// ADC0(VshuntM)I
		ADC_start_conv();							// ϊJn
		ADC_state = ADC_WAIT_CURRENT_MEAS;
		break;

	//----------------------------------------------------------------------------
	case ADC_WAIT_CURRENT_MEAS:						// d̎҂
		if(ADC_end_conv())							// ADCϊŁA
		{
			ADC_clear_end_conv_flag();				// ϊI荞׸މ
			current = ADC_data_reg();				// ADCް ڼ޽d擾

			Set_ADC_Channel(ADC7);					// ADC7(ϒR푬xM)I
			ADC_start_conv();						// ϊJn
			ADC_state = ADC_WAIT_SPEED_SET_MEAS;
		}
		break;
	//----------------------------------------------------------------------------

	case ADC_WAIT_SPEED_SET_MEAS:					// ]ޑx̎҂
		if(ADC_end_conv())							// ADCϊŁA
		{
			ADC_clear_end_conv_flag();				// ϊI荞׸މ
			Speed_set = ADC_data_reg();				// ADCް ڼ޽瑬x擾

			Set_ADC_Channel(ADC6);					// ADC6(VbatM)I
			ADC_start_conv();						// ϊJn
			ADC_state = ADC_WAIT_VBAT_MEAS;
		}
		break;
	//----------------------------------------------------------------------------

	case ADC_WAIT_VBAT_MEAS:
		if(ADC_end_conv())							// ADCϊŁA
		{
			ADC_clear_end_conv_flag();				// ϊI荞׸މ
			V_bat = ADC_data_reg();					// ADCް ڼ޽Vbatd擾

			Set_ADC_Channel(ADC0);					// ADC0(VshuntM)I
			ADC_start_conv();						// ϊJn
			ADC_state = ADC_WAIT_CURRENT_MEAS;
		}
		break;
	//----------------------------------------------------------------------------
	default:
		ADC_state = ADC_INIT_TASK;
		break;
	//----------------------------------------------------------------------------
	}
}

/*! @brief get_speed ]ޑxlԂ܂B
 */
unsigned int adc_get_speed(void)
{
	return Speed_set;
}

/*! @brief get_current 肵dԂ܂B
 */
unsigned int adc_get_current(void)
{
	return current;
}

/*! @brief get_V_bat 肵dԂ܂B
 */
unsigned int adc_get_V_bat(void)
{
	return V_bat;
}
